﻿Imports UniversalTicket
Public Class Form1
    Private WithEvents utc_kunde As New UTicketClient("127.0.0.1", 77, "holz-ist-cool-33", Me)
    Public bEingelogged As Boolean = False
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        utc_kunde.shutdown()
    End Sub
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        utc_kunde.start(generiereEinwegID)
        frmRegistrierung.utc_kunde = utc_kunde
        frmLogin.utc_kunde = utc_kunde
        frmLogin.ShowDialog()
        If bEingelogged = False Then
            Me.Close()
        End If
    End Sub
    Private Sub verbunden() Handles utc_kunde.ConnectionReadyForSending
        frmRegistrierung.btnRegistrieren.Enabled = True
        frmLogin.btnLogin.Enabled = True
    End Sub
    Private Function generiereEinwegID() As String
        Return (My.User.Name & My.Computer.Clock.LocalTime.ToString).GetHashCode
    End Function
    Private Sub utc_kunde_UTicketArrived(sSenderID As String, bSentToAll As Boolean, sCommand As String, oUserData As List(Of Object)) Handles utc_kunde.UTicketArrived
        Select Case sCommand
            Case "neue_liste_der_online_user"
                listeOnlineUser(oUserData)
            Case "nachricht_anzeigen"
                nachrichtAusgeben(CType(oUserData(0), Date), oUserData(1).ToString, oUserData(2).ToString)
        End Select
    End Sub
    Private Sub nachrichtAusgeben(ByVal datZeitpunkt As Date, ByVal sSender As String, ByVal sText As String)
        Dim sZeit As String = datZeitpunkt.Hour.ToString & ":" & datZeitpunkt.Minute.ToString
        rtbAusgabe.Text &= "[" & sZeit & "] " & sSender & ": " & sText & vbNewLine
    End Sub
    Private Sub listeOnlineUser(ByVal oUsernamen As List(Of Object))
        cmbEmpfänger.Items.Clear()
        For Each o In oUsernamen
            cmbEmpfänger.Items.Add(o.ToString)
        Next
    End Sub
    Private Sub txtTextZumSenden_KeyDown(sender As Object, e As KeyEventArgs) Handles txtTextZumSenden.KeyDown
        If e.KeyData = Keys.Enter Then
            textSenden()
        End If
    End Sub
    Private Sub textSenden()
        If txtTextZumSenden.Text <> "" Then
            Dim oDatenZumSenden As New List(Of Object)
            oDatenZumSenden.Add(cmbEmpfänger.Text)
            oDatenZumSenden.Add(txtTextZumSenden.Text)
            utc_kunde.sendUTicket("@master", "nachricht_weiterleiten", oDatenZumSenden)
            txtTextZumSenden.Text = ""
        End If
    End Sub
    Private Sub btnSenden_Click(sender As Object, e As EventArgs) Handles btnSenden.Click
        textSenden()
    End Sub
End Class
